<html><body>
<style>
code {COLOR: #800000; FONT-FAMILY: "Courier New", Courier, monospace}
</style>

<p> <b>SilentBob</b> </p>

<p><p> <table style="width: 32%; background: #C2D6FF; border: solid thin; padding: 6px; margin-bottom: 10px; margin-right: 10px; float: right;">
<tr> <th>Why using SilentBob for generating tags?</th> </tr>
<tr> <td>

</p> <p>SilentBob uses syntax analysis to parse source files, which makes it faster than a utility like Exuberant Ctags, which uses regular expressions to locate the appropriate line in a file. In a test run on the sources for the Linux kernel (version 2.6.19) Exuberant Ctags generated the tags table in 90 seconds, while SilentBob did its job in 10 seconds (on a 2.6MHz Celeron). SilentBob also supports multithreading optimizations.</p>

<p>Another difference is the format of tags tables: In tables created by Exuberant Ctags, regular expressions are used to locate the appropriate line in a file. This means that if you edit the file, and the position of some definition is changed, you don't need to rebuild the tags table. This is good for Exuberant Ctags because it means you don't need to regenerate the table often, but it also means that if you are viewing huge files, jumping to a tag definition will be much slower than if line numbers were used. That's why SilentBob uses line number in its tags tables; however, that means you have to update the tags table after every major edit. </p>

</td>
</tr>
</table>





<a href="http://silentbob.sourceforge.net/">SilentBob</a> is another new tool for analyzing source code. It currently supports C/C++, Perl, and Python, but its plugin framework (which is not documented at the moment) enables users to add support for new languages and other features easily. 

<p>You can get source tarball and deb packages from the downloads section of the software's site. After installation, invoke SilentBob three times in the directory with source code:</p>

<pre>
  bob --make-ctags
  bob --cfiles
  bob -L cfiles --call-tags
</pre>

<p>This will generate three files: <code>tags</code>, the common tags table; <code>cfiles</code>, a list of C/C++ files; and <code>call_tags</code>, the call tags table. The call tags table contains tags for function calls, so if you want to find all the calls of some function, you can point Vim to use the call tags table (<code>:set tags=./call_tags</code>) and use the same commands as for searching tags (<code>:tag <em>function-name</em> </code> and <code>:tnext</code> and <code>:tprevious</code> to cycle through results). These index files can be used by SilentBob to build call trees and backward call trees. </p>

<p>For Perl and Python, only tags tables and file lists are supported:</p>

<pre>
  bob &lt;--perl | --python&gt; --make-ctags
  bob &lt;--perl | --python&gt; --files
</pre>


The second command will generate a <code>perl_files</code> or <code>python_files</code> file.

<p>Once you have a tags table, SilentBob can show you a call tree:</p>

<pre>
  bob [--depth <em>N</em>] <em>function</em>
</pre>

<p> <code>--depth</code> option allows you to limit the depth of the tree. If the only thing you need to know is which functions are called by <em>function</em>, specify <code>--depth 0</code>. Otherwise, you will be shown which functions are called by functions called by functions (...) called by <em>function</em>. </p>

<p>Note that you can use this option with the tags table generated by SilentBob for Python and Perl files. Tables generated by Exuberant Ctags are not supported.</p>

<p>The call tags table is used to generate a backward call tree:</p>

<pre>
  bob [--depth <em>N</em>] -u <em>function</em>
</pre>

<p>This will show functions which call functions (...) which call <em>function</em>. In this case specify <code>--depth 1</code> to see only functions which call <em>function</em> </p>

<p>SilentBob can also use the created cfiles file to search for text within C/C++ code. It checks operators; strings and comments are ignored.</p>

<pre>
  bob <em>list of files</em> --cgrep <em>pieces of text, separated by comma</em>
</pre>

<p>You can specify <code>-L ./cfiles</code> to use generated file list. Pieces of text should be from one operator, so if you are looking for testing of T variable, use:</p>

<pre>
  bob -L ./cfiles --cgrep if,T
</pre>

<p>SilentBob also includes a <code>tags</code> utility that lets you to view the tag definitions in a C/C++ file in a console. Invoke <code>tags <em>tag1 tag2 ... tagN</em> </code> to strip the fragments of code you are interested in from code -- function definitions, global variable declarations, etc. -- and you will see the fragments of code you need. </p></div>

</body></html>